//*****************************************************************
// 
//  JAVA Source for com.idautomation.maxicode; 4.10
//  
//  Copyright, IDAutomation.com, Inc. 2000-2004. 
//  All rights reserved.
//  
//  http://www.IDAutomation.com/java/
//  
//  NOTICE:
//  You may incorporate our Source Code in your application
//  only if you own a valid Java Developer License
//  from IDAutomation.com, Inc. and the copyright notices 
//  are not removed from the source code.
//  
//*****************************************************************

package com.idautomation.maxicode;

import java.awt.*;
import java.awt.image.*;
import com.idautomation.maxicode.encoder.*;


/** this class paints a maxicode symbol
 */
public class MaxiCode extends Canvas
{

	public java.awt.Color color=java.awt.Color.black;
	public java.awt.Color backColor=java.awt.Color.white;

/**
 length in mm of the symbol
 */
	public double L=0; // mm
/**
 resolution of the printer in dpi, Default is 200.
 */
	private int resolution = 200; //dpi
	double dpm=8;
	double W=0; //mm
	double V=0;//mm
	double X=0;//mm
	double Y=0;//mm
	double H=0;//mm
	double tolerance=0.12;
	private int Wpixels=0; // pixel
	private int Vpixels=0; // pixel
	int Xpixels=0; // pixel
	int Ypixels=0; // pixel

	int Lpixels=0;
	int tolerancePixels=0;

/**
 paint the symbol at these coordinates
 */
        public int offsetX =0;
/**
 paint the symbol at these coordinates
 */
        public int offsetY =0;


	int r1=0; // pixel
	int r2=0; // pixel
	int r3=0; // pixel
	int r4=0; // pixel
	int r5=0; // pixel
	int r6=0; // pixel
	int rWidth=0;
	int centerX; // pixel
	int centerY; // pixel

	//****************************************
	//****************************************1=sale
	//****************************************3=demo
	protected final static int d=3;

	// accepted size after rounding to pixels
	private double La=0; // mm
	private double Ha=0;

	// current pattern for hexagons
/**
 pattern used to print a hexagon. If null the class will calculate the most appropiate pattern
 */
        private int[][] userPattern=null;
	private int[][] pattern=null;

	// temporary image
	java.awt.Image tmpImage=null;

/** maxicode mode: Values range from 2 to 6; default=2 for US; 3 = International and 4 = standard (non-shipping) symbols.
 */	private int mode=2;

	// fields for primary structure
/** postal code (modes 2 and 3) In mode 3 it can be an alphanumeric of length 5. In mode 2 can be a numeric of length 9.
 */
	private String zipCode="";

/** service class (modes 2 and 3). 
 */
	private String serviceClass="";
/** country code (modes 2 and 3)
 */
	private String country="";
/** data to be encoded. In modes 2 and 3 if the postal code is empty it will be extracted from the begining of this string (see maxicode specifications)
 */
	private String dataStr="NO DATA";

	// structured appended
/** number of symbol in structured appended mode
 */
	private int numberOfCodes=1;
/** position of this symbol in the secuence of the structured appended
 */
	private int positionOfCode=1;

	private boolean redraw=true;

	private int PAD=33;
	private int ECI=27;
	private int NSHIFT=31;
	private int SHIFTA=59;
	private int SHIFTB=59;
	private int SHIFTC=60;
	private int LOCKC=60;
	private int SHIFTD=61;
	private int LOCKD=61;
	private int SHIFTE=62;
	private int LOCKE=62;
	private int LACHTB=63;
	private int LACHTA_B=63; // when in mode B
	private int LACHTA=58;
	private int PADC=55;
	private int PADE=29;
	private int SHIFT2A=56;
	private int SHIFT3A=57;

	private char currentSet='A';

       /**
        * rotation angle. It can be 0,90,180 or 270
         */
        private int rotation=0;


        private boolean processTilde=true;

  private int prefW=0;
        private int prefH=0;

        private boolean autoResize=false;

        public boolean getProcessTilde() {return processTilde;}
        public void setProcessTilde(boolean pt) {processTilde=pt;}


        /** set a user defined pattern for the hexagons. For example:
*               int[][] pattern = {
*		{0,0,0,0,0,0,0},
*		{0,0,0,1,1,0,0},
*		{0,0,1,1,1,1,0},
*		{0,1,1,1,1,1,1},
*		{0,1,1,1,1,1,1},
*		{0,1,1,1,1,1,1},
*		{0,0,1,1,1,1,0},
*		{0,0,0,1,1,0,0},
*		};
*               myMaxicode.setPattern(pattern);
         *
         */
      public void setHexagonPattern(int[][] p) {
        this.userPattern=p;
      }


/**
    * Returns "MaxiCode".
    */
   public String getName()
   {
      return "MaxiCode";
   }

        /** width of hexagon modules (pixels)
         */
         public int getWHexagon() {
           return Wpixels;
         }

        /** Height of hexagon modules (pixels)
         */
         public int getHHexagon() {
           return Vpixels;
         }


/** maxicode mode. Values range from 2 to 6
 */	public void setMode(int m) {
   mode =m;
   redraw=true;
   // invalidate();
 }
/** maxicode mode. Values range from 2 to 6
 */
public int getMode() {
   return mode;
 }

/** postal code (modes 2 and 3)
 */
public String getZipCode() {
 return zipCode;
}
/** postal code (modes 2 and 3)
 */
public void setZipCode(String zp) {
 zipCode=zp;
 redraw=true;
}

/** service class (modes 2 and 3).
 */
public String getServiceClass() {
 return serviceClass;
}

/** service class (modes 2 and 3).
 */
public void setServiceClass(String s) {
 serviceClass=s;
 redraw=true;
}


/** country code (modes 2 and 3)
 */
 public String getCountry() {
 return country;
}

/** country code (modes 2 and 3)
 */
 public void setCountry(String c) {
   country=c;
   redraw=true;
}


/** data to be encoded. In modes 2 and 3 if the postal code is empty it will be extracted from the begining of this string (see maxicode specifications)
 */
  public String getData() {
 return dataStr;
}

/** data to be encoded. In modes 2 and 3 if the postal code is empty it will be extracted from the begining of this string (see maxicode specifications)
 */
  public void setData(String d) {
   dataStr=d;
   redraw=true;
   // invalidate();
}


/** number of symbol in structured appended mode
 */
  public int  getNumberOfCodes() {
    return numberOfCodes;
}

/** number of symbol in structured appended mode
 */
  public void  setNumberOfCodes(int n) {
    numberOfCodes=n;
    redraw=true;
}

/** position of this symbol in the secuence of the structured appended
 */
 /** number of symbol in structured appended mode
 */
  public int  getPositionOfCode() {
    return positionOfCode;
}

/** number of symbol in structured appended mode
 */
  public void  setPositionOfCode(int n) {
    positionOfCode=n;
   // invalidate();
}

     /**
        * rotation angle. It can be 0,90,180 or 270
         */
       public int getRotation() {
         return rotation;
       }

     /**
        * rotation angle. It can be 0,90,180 or 270
         */
       public void setRotation(int r) {
         rotation=r;
       }

        /** returns size needed to draw the symbol
          */
         public Dimension getPreferredSize() {
           return new Dimension(this.prefW,prefH);
         }

        /**
         * if true the image will be resized to fit the size available for the component. This is used to show the symbol on the screen.
         */
         public void setAutoResize(boolean b) {
           autoResize=b;
         }

         /**
          * if true the image will be resized to fit the size of the barcode
          */
         public boolean getAutoResize() {
           return autoResize;
         }

	// are the next "count" chars in "set"
	private boolean nextIn(String data,int pos,int count, char set) {

	   for (int i=pos;i<pos+count;i++)
		   if (this.charSet(data.charAt(i),set)==-1) return false;

	   return true;

	}

/** encodes a string in the maxicode character set
 */
	private byte[] encode(String data) {

		byte[] tmp=new byte[144];
		int count=0;
		int pos=0;
		int l=data.length();

		currentSet='A';


		while ((pos<l) && (count<144)) {

                        boolean done=false;

			// 9 digits?
			if ((l-pos)>=9)
				if (isDigit(data.charAt(pos)) &&
					isDigit(data.charAt(pos+1)) &&
					isDigit(data.charAt(pos+2)) &&
					isDigit(data.charAt(pos+3)) &&
					isDigit(data.charAt(pos+4)) &&
					isDigit(data.charAt(pos+5)) &&
					isDigit(data.charAt(pos+6)) &&
					isDigit(data.charAt(pos+7)) &&
					isDigit(data.charAt(pos+8)) )
					 {
			     byte[] digits = encode9Digits(data.substring(pos,pos+9));

                                 tmp[count++]=(byte) this.NSHIFT;
				 for (int i=0;i<5;i++) tmp[count++]=digits[i];
                                  done=true;
                                 pos=pos+9;

			}




			// MODE B
			if ((currentSet=='B') && (!done)) {

			  if ((!done) && (this.charSet(data.charAt(pos),'B')>=0)) {
				  tmp[count++]=(byte) this.charSet(data.charAt(pos),'B');
				  pos++;
				  done=true;
			  }


			  // in mode B, 4 chars A
			  if (((l-pos)>=4) && (!done))
				  if ((this.charSet(data.charAt(pos),'A')>=0) &&
						(this.charSet(data.charAt(pos+1),'A')>=0) &&
						(this.charSet(data.charAt(pos+2),'A')>=0) &&
						(this.charSet(data.charAt(pos+3),'A')>=0) )
						{
						  tmp[count++]= (byte) this.LACHTA_B;
						  tmp[count++]=(byte) this.charSet(data.charAt(pos),'A');
						  pos++;
						  done=true;
						  currentSet='A';
						}

			  // in mode B, 3 chars A
			  if (((l-pos)>=3) && (!done))
				  if ((this.charSet(data.charAt(pos),'A')>=0) &&
						(this.charSet(data.charAt(pos+1),'A')>=0) &&
						(this.charSet(data.charAt(pos+2),'A')>=0) )
						{
						  tmp[count++]=(byte) this.SHIFT3A;
						  tmp[count++]=(byte) this.charSet(data.charAt(pos),'A');
						  tmp[count++]=(byte) this.charSet(data.charAt(pos+1),'A');
						  tmp[count++]=(byte) this.charSet(data.charAt(pos+2),'A');
						  pos++;
						  pos++;
						  pos++;
						  done=true;
						}

			  // in mode B, 2 chars A
			  if (((l-pos)>=2) && (!done))
			  	  if ((this.charSet(data.charAt(pos),'A')>=0) &&
						(this.charSet(data.charAt(pos+1),'A')>=0) )
						{
						  tmp[count++]= (byte) this.SHIFT2A;
						  tmp[count++]=(byte) this.charSet(data.charAt(pos),'A');
						  tmp[count++]=(byte) this.charSet(data.charAt(pos+1),'A');
						  pos++;
						  pos++;
						  done=true;
						}

			  // in mode B, 1 char A
			  if ((!done) && (this.charSet(data.charAt(pos),'A')>=0)) {
						  tmp[count++]=(byte) this.SHIFTA;
						  tmp[count++]=(byte) this.charSet(data.charAt(pos),'A');
						  pos++;
						  done=true;
			 }


			}



			// MODE A
			if ((currentSet=='A') && (!done)) {
				if ((!done) && (this.charSet(data.charAt(pos),'A')>=0)) {

						  tmp[count++]=(byte) this.charSet(data.charAt(pos),'A');
						  pos++;
						  done=true;
				}


			    // in mode A , 2 chars B
				if (((l-pos)>=2) && (!done))
			  	  if ((this.charSet(data.charAt(pos),'B')>=0) &&
						(this.charSet(data.charAt(pos+1),'B')>=0) &&  (this.charSet(data.charAt(pos+1),'A')==-1))
						{
						  tmp[count++]=(byte) this.LACHTB;
						  tmp[count++]=(byte) this.charSet(data.charAt(pos),'B');
						  pos++;
						  done=true;
						  currentSet='B';
						}

			    // in mode A , 1 chars B
			    if ((!done) && (this.charSet(data.charAt(pos),'B')>=0)) {
						  tmp[count++]=(byte) this.SHIFTB;
						  tmp[count++]=(byte) this.charSet(data.charAt(pos),'B');
						  pos++;
						  done=true;
			    }

			}


			if ((currentSet<='B') && (!done)) {
				// in mode A or B, 4 chars C,D or E
				if (((l-pos)>=4) && (!done))
				  if ((this.charSet(data.charAt(pos),'C')>=0) &&
						(this.charSet(data.charAt(pos+1),'C')>=0) &&
						(this.charSet(data.charAt(pos+2),'C')>=0) &&
						(this.charSet(data.charAt(pos+3),'C')>=0) )
						{
						  tmp[count++]=(byte) this.SHIFTC;
						  tmp[count++]=(byte) this.LOCKC;
						  tmp[count++]=(byte) this.charSet(data.charAt(pos),'C');
						  pos++;
						  done=true;
						  currentSet='C';
						}


				if (((l-pos)>=4) && (!done))
				  if ((this.charSet(data.charAt(pos),'D')>=0) &&
						(this.charSet(data.charAt(pos+1),'D')>=0) &&
						(this.charSet(data.charAt(pos+2),'D')>=0) &&
						(this.charSet(data.charAt(pos+3),'D')>=0) )
						{
						  tmp[count++]=(byte) this.SHIFTD;
						  tmp[count++]=(byte) this.LOCKD;
						  tmp[count++]=(byte) this.charSet(data.charAt(pos),'D');
						  pos++;
						  done=true;
						  currentSet='D';
						}

				if (((l-pos)>=4) && (!done))
				  if ((this.charSet(data.charAt(pos),'E')>=0) &&
						(this.charSet(data.charAt(pos+1),'E')>=0) &&
						(this.charSet(data.charAt(pos+2),'E')>=0) &&
						(this.charSet(data.charAt(pos+3),'E')>=0) )
						{
						  tmp[count++]=(byte) this.SHIFTE;
						  tmp[count++]=(byte) this.LOCKE;
						  tmp[count++]=(byte) this.charSet(data.charAt(pos),'E');
						  pos++;
						  done=true;
						  currentSet='E';
						}


				// in mode A or B, 1 char C,D or E
			    if ((!done) && (this.charSet(data.charAt(pos),'C')>=0)) {
						  tmp[count++]=(byte) this.SHIFTC;
						  tmp[count++]=(byte) this.charSet(data.charAt(pos),'C');
						  pos++;
						  done=true;
			    }

			    if ((!done) && (this.charSet(data.charAt(pos),'D')>=0)) {
						  tmp[count++]=(byte) this.SHIFTD;
						  tmp[count++]=(byte) this.charSet(data.charAt(pos),'D');
						  pos++;
						  done=true;
			    }

			    if ((!done) && (this.charSet(data.charAt(pos),'E')>=0)) {
						  tmp[count++]=(byte) this.SHIFTE;
						  tmp[count++]=(byte) this.charSet(data.charAt(pos),'E');
						  pos++;
						  done=true;
			    }


			}


			if ((currentSet>'B') && (!done)) {
			// in mode C, D or E

				// if now A
				if ((!done) && (this.charSet(data.charAt(pos),'A')>=0)) {
						  tmp[count++]=(byte) this.LACHTA;
						  tmp[count++]=(byte) this.charSet(data.charAt(pos),'A');
						  pos++;
						  done=true;
						  currentSet='A';
			    }

				// if now B
				if ((!done) && (this.charSet(data.charAt(pos),'B')>=0)) {
						  tmp[count++]=(byte) this.LACHTB;
						  tmp[count++]=(byte) this.charSet(data.charAt(pos),'B');
						  pos++;
						  done=true;
						  currentSet='B';
			    }


			    // if more than 1 C , D or E
				if (((l-pos)>=2) && (!done))
			  	  if ((this.charSet(data.charAt(pos),'C')>=0) &&
						(this.charSet(data.charAt(pos+1),'C')>=0) && (currentSet!='C') )
						{
						 if (currentSet!='C') {
						   tmp[count++]=(byte) this.SHIFTC;
						   tmp[count++]=(byte) this.LOCKC;
						 }
						 tmp[count++]=(byte) this.charSet(data.charAt(pos),'C');
						 pos++;
						 done=true;
						 currentSet='C';
						}

				if (((l-pos)>=2) && (!done))
			  	  if ((this.charSet(data.charAt(pos),'D')>=0) &&
						(this.charSet(data.charAt(pos+1),'D')>=0) && (currentSet!='D'))
						{
					 if (currentSet!='D') {
						   tmp[count++]=(byte) this.SHIFTD;
						   tmp[count++]=(byte) this.LOCKD;
						 }
						 tmp[count++]=(byte) this.charSet(data.charAt(pos),'D');
						 pos++;
						 done=true;
						 currentSet='D';
						}

				if (((l-pos)>=2) && (!done))
			  	  if ((this.charSet(data.charAt(pos),'E')>=0) &&
						(this.charSet(data.charAt(pos+1),'E')>=0)  && (currentSet!='E'))
						{
					 if (currentSet!='E') {
						   tmp[count++]=(byte) this.SHIFTE;
						   tmp[count++]=(byte) this.LOCKE;
						 }
						 tmp[count++]=(byte) this.charSet(data.charAt(pos),'E');
						 pos++;
						 done=true;
						 currentSet='E';
						}


				// if only 1 C , D or E
				if ((!done) && (this.charSet(data.charAt(pos),'C')>=0)) {
						  if (currentSet!='C') tmp[count++]=(byte) this.SHIFTC;
						  tmp[count++]=(byte) this.charSet(data.charAt(pos),'C');
						  pos++;
						  done=true;
			    }
			    if ((!done) && (this.charSet(data.charAt(pos),'D')>=0)) {
						  if (currentSet!='D') tmp[count++]=(byte) this.SHIFTD;
						  tmp[count++]=(byte) this.charSet(data.charAt(pos),'D');
						  pos++;
						  done=true;
			    }
			    if ((!done) && (this.charSet(data.charAt(pos),'E')>=0)) {
						  if (currentSet!='E') tmp[count++]=(byte) this.SHIFTE;
						  tmp[count++]=(byte) this.charSet(data.charAt(pos),'E');
						  pos++;
						  done=true;

			    }

			}


		}

		// latch to A or B
		if (currentSet!='B') tmp[count++]=(byte) this.LACHTB;
                else tmp[count++]=(byte) this.LACHTA_B;

		for (int i= count;i<144;i++) tmp[count++]=(byte) this.PAD;

		return tmp;

	}

/** convert from bits to integer
 */
	private byte parseBits(String vStr) {

            int v=0;

			if (vStr.charAt(0)=='1') v=v+32;
			if (vStr.charAt(1)=='1') v=v+16;
			if (vStr.charAt(2)=='1') v=v+8;
			if (vStr.charAt(3)=='1') v=v+4;
			if (vStr.charAt(4)=='1') v=v+2;
			if (vStr.charAt(5)=='1') v=v+1;

			return (byte) v;

	}


/** encode 9 consecutive digits
 */
	private byte[] encode9Digits(String s) {

		int Int=0;
		  try {
			 Int=new Integer(s).intValue();
		  } catch (Exception e1) {Int=0;};

		String tmp=getBits(Int,30);

		byte[] data= new byte[5];

		for (int i=0;i<5;i++) data[i]=parseBits(tmp.substring(i*6,(i+1)*6));

		return data;

	}


/**
 Apply the Reed Solomon algorithm
 */
	private void addReedSolomon(byte[] data) {
		int[] primary=new int[144];
		int[] secondaryEven=new int[144];
		int[] secondaryOdd=new int[144];
		reed6 RS=new reed6();

		// extract primary
		for (int i=0;i<10;i++)  primary[i]=data[i];
		for (int i=10;i<20;i++)  primary[i]=0;

		// RS for primary
		RS.calcRS(primary,10,10);

		// extract interleaved blocks
		int j=0;
		for (int i=0;i<124;i=i+2) {
			secondaryEven[j]=data[20+i];
			secondaryOdd[j]=data[20+i+1];
			j++;
		}

		int k=42;
		int t2=20;

		if (mode ==5) {
			k=34;
			t2=28;
		}

		// calculate RS for interleaved blocks
		RS.calcRS(secondaryEven,k,t2);
		RS.calcRS(secondaryOdd,k,t2);

		// move data to the final array
		for (int i=0;i<20;i++) data[i]=(byte) primary[i];
		j=20;
		for (int i=0;i<62;i++) {
			data[j]=(byte) secondaryEven[i];
			j++;
			data[j]=(byte) secondaryOdd[i];
			j++;
		}


	}


/**
 apply tilde
 */
  private String applyTilde(String code) {
	   int i;

	   int c=0;
	   int longi=code.length();
	   String result="";
	   boolean done=false;

	   for (i=0;i<longi;i++) {

		   c=(int) code.charAt(i);

		   if (c=='~') {
			   // process special cases

			   if (i<(longi-1)) {

			   char nextc=code.charAt(i+1);


			   // quoting character
			   if (nextc=='~') {
				  result=result+'~';
				  i++;
			   } else {

			   // dNNN
			    if (i<(longi-3)) {
				   String ascString=code.substring(i+1,i+4);

				   int asc=0;
				   try {
				     asc= new Integer(ascString).intValue();
				   } catch (Exception e) {asc=0;}

				   if (asc>255) asc=255;

				   // the ascii value
				   result=result+(char) asc;

				   i=i+3;
			   }
                           } // not escape

			   } // we have two chars at least

		   } else {
			   // no tilde
			   result=result+(char) c;
		   }



	   }

	   return result;
   }


/**
 Set resolution of the printer (in dpi). The default is 200 dpi.
 */
	public boolean setResolution(int r) {

 		resolution=r;
		return setL(L);

	}
/**
 Get current resolution of the printer (in dpi)
 */

        public int getResolution() { return resolution; }
/**
 Set length of length symbol. The default is 25.5 millimeters.
 */

	public boolean setL(double l) {


	  dpm=resolution/25; // dpi to dpm
	  r1=(int) java.lang.Math.round((0.51)*dpm);
	  r2=(int) java.lang.Math.round((1.18)*dpm);
	  r3=(int) java.lang.Math.round((1.86)*dpm);
	  r4=(int) java.lang.Math.round((2.53)*dpm);
	  r5=(int) java.lang.Math.round((3.20)*dpm);
	  r6=(int) java.lang.Math.round((3.87)*dpm);

	  L=l;


	  W=(L/29);
	  V=(2/java.lang.Math.sqrt(3))*W;
	  X=W;
	  Y=(1.5/java.lang.Math.sqrt(3))*W;
	  H=32*Y;

	  Lpixels=(int) (L*dpm);
	  Xpixels=(int) java.lang.Math.round(Lpixels/29);
	  Wpixels=Xpixels;

	  Vpixels=(int) java.lang.Math.round((2/java.lang.Math.sqrt(3))*Wpixels);
	  Ypixels=(int) java.lang.Math.round((1.5/java.lang.Math.sqrt(3))*Wpixels);

	  La=0;
	  Ha=0;

	  La=(Xpixels*29)/dpm;
	  Ha=(Ypixels*32)/dpm;

	  boolean inLimits=true;

	  if ((La<24) || (La>27)) inLimits=false;
	  if ((Ha<22.9) || (Ha>25.8)) inLimits=false;

	  if (!inLimits) {

		// round Xpixels the other way
		double tmpXpixels=Xpixels;

	    if (tmpXpixels>(Lpixels/29)) Xpixels--;
		else Xpixels++;

	    Wpixels=Xpixels;
	    Vpixels=(int) java.lang.Math.round((2/java.lang.Math.sqrt(3))*Wpixels);
	    Ypixels=(int) java.lang.Math.round((1.5/java.lang.Math.sqrt(3))*Wpixels);

	    La=(Xpixels*29)/dpm;
	    Ha=(Ypixels*32)/dpm;

		inLimits=true;
		if ((La<24) || (La>27)) inLimits=false;
		if ((Ha<22.9) || (Ha>25.8)) inLimits=false;

		if (!inLimits) return false;

	}


	centerY=((int) (Vpixels/2))+(16*Ypixels);
	centerX=((int) (Xpixels/2))+(14*Xpixels);
	tolerancePixels=(int) java.lang.Math.round(tolerance*dpm);

        this.prefW=this.Xpixels*30;
	this.prefH=(this.Ypixels*32)+this.Vpixels;

//***************************************** demo
//***************************************** for non-demo rem out next 2 lines
        //prefW=prefW+30;
        //prefH=prefH+30;

	return true;


	}



	private static int[][] layout;


/**
 layout of the hexagons at 12 dpm
 */
	int[][] pattern12dpm = {
		{0,0,0,0,0,0,0,0,0,0},
		{0,0,0,0,1,1,1,0,0,0},
		{0,0,0,1,1,1,1,1,0,0},
		{0,0,1,1,1,1,1,1,1,0},
		{0,1,1,1,1,1,1,1,1,1},
		{0,1,1,1,1,1,1,1,1,1},
		{0,1,1,1,1,1,1,1,1,1},
		{0,1,1,1,1,1,1,1,1,1},
		{0,0,1,1,1,1,1,1,1,0},
		{0,0,0,1,1,1,1,1,0,0},
		{0,0,0,0,1,1,1,0,0,0},
		{0,0,0,0,0,0,0,0,0,0}
	};
/**
 layout of the hexagons at 16 dpm
 */
        int[][] pattern16dpm = {
		{0,0,0,0,0,0,0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,1,1,0,0,0,0,0},
		{0,0,0,0,0,1,1,1,1,1,1,0,0,0},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,0},
		{0,0,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,0},
		{0,0,0,0,0,1,1,1,1,1,1,0,0,0},
		{0,0,0,0,0,0,0,1,1,0,0,0,0,0}
	};
/**
 layout of the hexagons at 20 dpm
 */
       int[][] pattern20dpm = {
		{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
                {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0},
		{0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0},
		{0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
                {0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0},
                {0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0},
                {0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0},
                {0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0}
	};

/**
 layout of the hexagons at 24 dpm
 */
 int[][] pattern24dpm = {
		{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
                {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
                {0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0},
                {0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0},
		{0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
                {0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0},
                {0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0},
                {0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0},
                {0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0}
	};

/**
 layout of the hexagons at 8 dpm
 */
	int[][] pattern8dpm = {
		{0,0,0,0,0,0,0},
		{0,0,0,1,1,0,0},
		{0,0,1,1,1,1,0},
		{0,1,1,1,1,1,1},
		{0,1,1,1,1,1,1},
		{0,1,1,1,1,1,1},
		{0,0,1,1,1,1,0},
		{0,0,0,1,1,0,0},
		};


/**
  Constructor
 */
	public  MaxiCode() {
		super();


		//this.serviceClas="999";
		//this.country="056";
		//this.zipCode="999999999";
		//this.mode=2;
		//this.createPrimary();

		setL(25.5);
		if (layout==null) createLayout();
	}

/**
 convert from int to bit string
 */
	private String getBits(int c,int num) {

	  String bits=Integer.toBinaryString(c);

	  if (bits.length()<num)
		  for (int i=bits.length();i<num;i++) bits="0"+bits;
	  else bits=bits.substring(bits.length()-num,bits.length());

	  return bits;

	}

/**
 create primary message in mode 2 and 3
 */
	private byte[] createPrimary() {




		byte[] data=new byte[20];
		String bitStream="";

		// switch to mode 3 if necesary
		for (int i=0;i<this.zipCode.length();i++)
			// postal code is not numeric, mode 3
			if (!isDigit(this.zipCode.charAt(i))) this.mode=3;


		// add spaces to zip code in mode 3
		if ((this.mode==3) && (this.zipCode.length()<6))
			for (int i=this.zipCode.length();i<6;i++) this.zipCode=this.zipCode+" ";


		// encode postal code
		String zipCodeBinary2="";
		String zipCodeBinary3="";
		String zipCodeLength2="";
		for (int i=0;i<this.zipCode.length();i++)
			// mode 3 only encodes up to 6 chars
			if (i<6) zipCodeBinary3=zipCodeBinary3+getBits(this.charSet(this.zipCode.charAt(i),'A'),6);




		if (this.mode==2) {

   		// mode 2 up to 9 digits
		  if (this.zipCode.length()>9) this.zipCode=this.zipCode.substring(0,9);

		  // encode class service
		  int zipCodeInt=0;
		  try {
			 zipCodeInt=new Integer(this.zipCode).intValue();
		  } catch (Exception e1) {zipCodeInt=0;};

		  zipCodeBinary2=getBits(zipCodeInt,30);
		  zipCodeLength2=getBits(this.zipCode.length(),6);

		}


		String modeBits="0011";
		if (this.mode==2) modeBits="0010";


		// encode class service
		int service=0;
		try {
			service=new Integer(this.serviceClass).intValue();
		} catch (Exception e1) {service=0;};

		// encode country
		int countryInt=0;
		try {
			countryInt=new Integer(this.country).intValue();
		} catch (Exception e1) {countryInt=0;};


		// add last 2 bits of the postcode to the first byte


		if (mode==2) bitStream=getBits(service,10)+getBits(countryInt,10)+zipCodeLength2+zipCodeBinary2+modeBits;
		else bitStream=getBits(service,10)+getBits(countryInt,10)+zipCodeBinary3+modeBits;

		if (bitStream.length()!=60) {
			System.out.println("Wrong bitStream in primary Message "+bitStream);
			return data;
		}

		for (int j=0;j<10;j++) {

			String vStr=bitStream.substring(j*6,(j+1)*6);

			data[10-j-1]=parseBits(vStr);
		}

		return data;


	}



	private char getCharSet(int c) {

		int i=0;
		i=c-1;

		while (i<this.table.length) {

			if (table[i][0]==c)
				// return charset
				return (char) table[i][1];

			// the index is too high
			if (table[i][0]>c) break;

			i++;
		}


		return ' ';
	}



/**
 returns true if the character is a digit
 */
	private boolean  isDigit(int c) {
		return ((c>='0') && (c<='9'));
	}




/**
 returns value of the char (c) in the character set (cs), or -1 if not in the character set
 */
	private int charSet(int c,char cs) {

		int i=0;
		i=c-1;

		while (i<this.table.length) {

			if (table[i][0]==c)
				if (table[i][1]==cs) return table[i][2];

			// the index is too high
			if (table[i][0]>c) break;

			i++;
		}


		return -1;
	}

/**
  extract postal code, country and service from the data
 */
	private String extractPrimaryData(String data) {

	    char GS=29;
		char RS=30;
		int startPosition=0;
                String year="";

		if (data.substring(0,7).compareTo("[)>"+RS+"01"+GS)==0) {
                   startPosition=9;
                }
		else startPosition=0;



		int	element=0;
		int i;
		for (i=startPosition;i<data.length();i++) {
		   if (data.charAt(i)==GS) element++;
		   else {
				  if (element==0) this.zipCode=this.zipCode+data.charAt(i);
				  if (element==1) this.country=this.country+data.charAt(i);
				  if (element==2) this.serviceClass=this.serviceClass+data.charAt(i);
		   }

		   // exit, we have all three fields
		   if (element==3) break;

		 }

		 if (i<data.length()) data=data.substring(0,startPosition)+data.substring(i+1,data.length());
		 else data=data.substring(0,startPosition);

		 return data;

	}


	private void layoutHexagon(int x,int y,int c) {

	  int base=(c-1)*6;

	  layout[x][y]=base+2;
	  layout[x+1][y]=base+1;
	  layout[x][y+1]=base+4;
	  layout[x+1][y+1]=base+3;
	  layout[x][y+2]=base+6;
	  layout[x+1][y+2]=base+5;

	}


	private void layoutHexagon2(int x,int y,int c) {

	  int base=(c-1)*6;

	  layout[x][y]=base+1;
	  layout[x+1][y+1]=base+2;
	  layout[x][y+1]=base+3;
	  layout[x][y+2]=base+4;
	  layout[x+1][y+3]=base+5;
	  layout[x][y+3]=base+6;


	}

	private void hexagonList(int start,int end,int x,int y) {

		 int i=start;
		 int step=1;
		 if (end<start) step=-1;

		 while (i!=end) {
			 layoutHexagon(x,y,i);
			 x=x+2;
			 i=i+step;
		 }

	}

/**
 create a layout in the symbol
 */
	private void createLayout() {

		layout=new int[30][33];

		hexagonList(21,35,0,0);
		hexagonList(48,34,0,3);
		hexagonList(49,63,0,6);
		hexagonList(69,65,0,9);
		hexagonList(70,73,0,12);
		hexagonList(81,78,0,15);
		hexagonList(82,85,0,18);
		hexagonList(94,90,0,21);
		hexagonList(95,109,0,24);
		hexagonList(122,108,0,27);
		hexagonList(123,137,0,30);
		hexagonList(65,62,22,9);
		hexagonList(73,76,22,12);
		hexagonList(78,75,22,15);
		hexagonList(85,88,22,18);
		hexagonList(90,87,22,21);

		layoutHexagon(8,9,14);
		layoutHexagon(8,12,10);
		layoutHexagon(6,12,18);
		layoutHexagon(8,18,11);
		layoutHexagon(6,18,17);
		layoutHexagon(8,21,13);
		layoutHexagon(20,9,19);
		layoutHexagon(20,12,15);
		layoutHexagon(20,18,16);
		layoutHexagon(20,21,20);
		layoutHexagon(18,21,12);

		layoutHexagon2(28,1,137);
		layoutHexagon2(28,5,138);
		layoutHexagon2(28,9,139);
		layoutHexagon2(28,13,140);
		layoutHexagon2(28,17,141);
		layoutHexagon2(28,21,142);
		layoutHexagon2(28,25,143);
		layoutHexagon2(28,29,144);

		// back or white
		layout[28][0]=-1;
		layout[29][0]=-1;

		layout[10][9]=-1;
		layout[11][9]=-1;
		layout[11][10]=-1;

		layout[17][9]=0;
		layout[17][9]=0;
		layout[18][10]=0;

		layout[7][15]=-1;
		layout[7][16]=0;
		layout[8][16]=-1;

		layout[20][16]=-1;
		layout[21][16]=0;
		layout[20][17]=-1;



		layout[10][22]=-1;
		layout[11][22]=0;
		layout[10][23]=-1;

		layout[17][22]=-1;
		layout[16][23]=0;
		layout[17][23]=-1;

		// other
		layout[12][9]=14;
		layout[13][9]=13;
		layout[14][9]=38;
		layout[15][9]=37;
		layout[16][9]=3;
		layout[18][9]=45;
		layout[19][9]=44;

		layout[10][10]=41;
		layout[12][10]=16;
		layout[13][10]=15;
		layout[14][10]=40;
		layout[15][10]=39;
		layout[16][10]=4;
		layout[19][10]=46;

		layout[10][11]=42;
		layout[16][11]=6;
		layout[17][11]=5;
		layout[18][11]=48;
		layout[19][11]=47;

		layout[10][12]=17;
		layout[18][12]=21;
		layout[19][12]=20;

		layout[18][13]=23;
		layout[19][13]=22;

		layout[19][14]=24;

		layout[6][15]=49;
		layout[8][15]=31;
		layout[19][15]=1;
		layout[20][15]=54;
		layout[21][15]=53;

		layout[6][16]=50;

		layout[6][17]=52;
		layout[7][17]=51;
		layout[8][17]=32;
		layout[19][17]=2;
		layout[21][17]=43;

		layout[19][18]=27;

		layout[18][19]=29;
		layout[19][19]=28;

		layout[10][20]=18;
		layout[18][20]=19;
		layout[19][20]=30;

		layout[10][21]=33;
		layout[17][21]=11;

		layout[12][22]=8;
		layout[13][22]=7;
		layout[14][22]=36;
		layout[15][22]=35;
		layout[16][22]=12;

		layout[11][23]=34;
		layout[12][23]=10;
		layout[13][23]=9;
		layout[14][23]=26;
		layout[15][23]=25;




	}


	/** paints a module
	 */
	private void paintModule(Graphics g2,int x,int y,int[][] pattern,java.awt.Color c) {
		int w=pattern[0].length;
		int h=pattern.length;

		g2.setColor(c);
		for (int i=0;i<w;i++)
			for (int j=0;j<h;j++) {
			  if (pattern[j][i]==1) g2.drawLine(x+i,y+j,x+i,y+j);
			}


	}

/**
  creates a hexagon pattern, if a standard cannot be used.
 */
	public int[][] createPattern() {
		int[][] p=new int[Vpixels][Xpixels];
		int[][] ptmp=new int[Vpixels-tolerancePixels][Xpixels-tolerancePixels];


		// arrays reset
		for (int i=0;i<p[0].length;i++)
			for (int j=0;j<p.length;j++)
				p[j][i]=0;

		for (int i=0;i<ptmp[0].length;i++)
			for (int j=0;j<ptmp.length;j++)
				ptmp[j][i]=1;


		int overlap=Vpixels-Ypixels;

		int hexagonTopSide=(int) java.lang.Math.floor(ptmp[0].length/3);
		int pixelsToRemove=(ptmp[0].length-hexagonTopSide)/2;

		// set to 0 the corners
		for (int i=0;i<pixelsToRemove;i++)
			for (int j=0;j<(pixelsToRemove-i);j++) {
				ptmp[j][i]=0; // left top
				ptmp[j][ptmp[0].length-1-i]=0;  // right top
				ptmp[ptmp.length-j-1][i]=0; // left bottom
				ptmp[ptmp.length-j-1][ptmp[0].length-1-i]=0;  // right bottom

			}



		for (int i=0;i<ptmp[0].length;i++)
			for (int j=0;j<ptmp.length;j++)
				p[j+tolerancePixels][i+tolerancePixels]=ptmp[j][i];


		// for debug only
		//String line="";
		//for (int j=0;j<Vpixels;j++) {
		//	line="";
		//	for (int i=0;i<Xpixels;i++){
		//		line=line+p[j][i]+" ";
		//	}
		//	System.out.println(line);
		//}

		return p;

	}


/**
 force recalculating the symbol next time paint() is called
 */
  public void setRedraw(boolean b) {
    redraw=b;
    pattern=null;
  }


/** paints the barcode and rotates it if necessary
 */





 /**
 paints the maxicode symbol.
 */
	public void paint(Graphics g) {


	   if (tmpImage==null) redraw=true;

		if (redraw) 
		{

			redraw=false;

			try 
			{
				// this will only return an image is the component is being shown in the screen
				tmpImage=this.createImage(prefW,prefH);
			} 
			catch (Exception e) {tmpImage=null;};

			java.awt.Graphics g2=g;
			if (tmpImage!=null) g2=tmpImage.getGraphics();

			// use pattern specified by user
			if (pattern==null) pattern=this.userPattern;

			// use the 2 hardcoded patterns
			if ((Wpixels==7) && (Vpixels==8) && (pattern==null)) pattern=this.pattern8dpm;
			if ((Wpixels==10) && (Vpixels==12) && (pattern==null)) pattern=this.pattern12dpm;
			if ((Wpixels==14) && (Vpixels==16) && (pattern==null)) pattern=this.pattern16dpm;
			if ((Wpixels==17) && (Vpixels==20) && (pattern==null)) pattern=this.pattern20dpm;
			if ((Wpixels==20) && (Vpixels==24) && (pattern==null)) pattern=this.pattern24dpm;

			// create new pattern
			if (pattern==null) pattern=this.createPattern();


			g2.setColor(this.color);

			if (pattern==null) pattern=this.createPattern();


			g2.setColor(this.backColor);
			g2.fillRect(0,0,prefW,prefH);
			g2.fillRect(0,0,this.getSize().width,this.getSize().height);

			//***************************************** demo
			//***************************************** demo next 3 lines
			// demo
			// g2.setColor(this.color);
			// g2.drawString("IDAUTOMATION.COM DEMO",20,prefH-20);


			// draw finder pattern
			g2.setColor(this.color);
			g2.fillArc(centerX-r6,centerY-r6,r6*2,r6*2,0,360);
			g2.setColor(this.backColor);
			g2.fillArc(centerX-r5,centerY-r5,r5*2,r5*2,0,360);
			g2.setColor(this.color);
			g2.fillArc(centerX-r4,centerY-r4,r4*2,r4*2,0,360);
			g2.setColor(this.backColor);
			g2.fillArc(centerX-r3,centerY-r3,r3*2,r3*2,0,360);
			g2.setColor(this.color);
			g2.fillArc(centerX-r2,centerY-r2,r2*2,r2*2,0,360);
			g2.setColor(this.backColor);
			g2.fillArc(centerX-r1,centerY-r1,r1*2,r1*2,0,360);

			byte bitValue;
			int bit;
			int car;


			byte[] dataTMP=new byte[144];
			byte[] primary=new byte[20];

			String tmpDataStr=dataStr;
			// process tilde
			if (this.getProcessTilde()) tmpDataStr=this.applyTilde(dataStr);

			// extract zip code...
			if ((mode==2) || (mode==3)) 
			{
				if (this.zipCode.length()==0) tmpDataStr=this.extractPrimaryData(tmpDataStr);

				primary=createPrimary();
			}


			dataTMP=this.encode(tmpDataStr);

			// structured appended?
			byte structuredAppendedChar=(byte) this.parseBits(this.getBits(this.positionOfCode-1,3)+this.getBits(this.numberOfCodes-1,3));

			// if structured append
			if (this.numberOfCodes>1) 
			{
				// mode back 2 positions all dtaa in the array
				for (int i=141;i>=0;i--) dataTMP[i+2]=dataTMP[i];

				// add structure append bytes
				dataTMP[0]=(byte) this.PAD;
				dataTMP[1]=structuredAppendedChar;
			}


			if (mode>3) 
			{

				// 9 first word into primary message
				for (int i =0;(i<9);i++) primary[i+1]=dataTMP[i];

				primary[0]=(byte) mode;

				// update secondary message
				for (int i=9;i<144;i++) dataTMP[i-9]=dataTMP[i];
			}


			byte[] finalData= new byte[144];

			for (int i=0;i<10;i++) finalData[i]=primary[i];
			for (int i=20;i<144;i++) finalData[i]=dataTMP[i-20];

			// add SEC
			this.addReedSolomon(finalData);


			int tmpx=0;
			int tmpy=0;
			boolean even=true;

			for (int j=0;j<33;j++) 
			{
				tmpx=0;
				if (!even) tmpx=(int) (Xpixels/2);

				for (int i=0;i<30;i++) 
				{
					// always black module
					//layout[14][16]=-1;
					if (layout[i][j]==-1) 
					{
						paintModule(g2,tmpx,tmpy,pattern,this.color);
					}

					// normal value
					if (layout[i][j]>0) 
					{
						car=(int) java.lang.Math.floor((layout[i][j]-1)/6);

						bit=layout[i][j]-(car*6);
						bitValue=0;

						if (layout[i][j]==1) 
						{
							int hh=0;
						}

						if (bit==1) bitValue=32;
						if (bit==2) bitValue=16;
						if (bit==3) bitValue=8;
						if (bit==4) bitValue=4;
						if (bit==5) bitValue=2;
						if (bit==6) bitValue=1;

						java.awt.Color c=this.color;


						//if (car<20) c=java.awt.Color.red;
						//else {
						//  if (car<30) {
						//       c=java.awt.Color.blue;
						//  }
						//}


						if ((finalData[car] & bitValue)>0)  paintModule(g2,tmpx,tmpy,pattern,c);

					}

					tmpx=tmpx+this.Wpixels;
				}

				even=!even;
				tmpy=tmpy+this.Ypixels;
			}


		// demo
		if (d!=1) {
			java.util.Calendar calendar=java.util.Calendar.getInstance();
			int ml=calendar.get(java.util.Calendar.MILLISECOND);
			//for non demo rem out next 6 lines 
			if (ml<400) 
			{
				g2.setColor(this.backColor);
				g2.fillRect(centerX-r6,centerY-r6,r6*2,r6*2);
				g2.setColor(this.color);
				g2.drawString(""+((char) 68)+((char) 69)+((char) 77)+((char) 79),centerX-r6,centerY);
			}
		}

	   }
	   // rotate and copy final image, if we used a temporary
	   if (tmpImage!=null) {
               Image tmpImage2=tmpImage;
               if (rotation!=0) tmpImage2=this.rotate(tmpImage,rotation,prefW,prefH);

               if ((autoResize) && ((prefW>this.getSize().width) || (prefH>this.getSize().height))) {
                 // first try to use full width
                 int newW=this.getSize().width;
                 int newH= (int) ((double) (newW*this.prefH)/this.prefW);

                 // use full height
                 if (newH>this.getSize().height) {
                     newH=this.getSize().height;
                     newW=(int)  ((double) (newH*this.prefW)/this.prefH);
                 }

                 // copy and schrink image
                 g.drawImage(tmpImage2,offsetX,offsetY,offsetX+newW,offsetY+newH,0,0,prefW,prefH,null);

               } // copy image
              else g.drawImage(tmpImage2,offsetX,offsetY,null);
           }

	}



 // function to rotate an area of an image, 90, 180 or 270 degrees
/** rotates an image
 */
   protected Image rotate(Image im, int angle,int maxw, int maxh) {
        int w=im.getWidth(null);
        int h= im.getHeight(null);

		if (maxw > w ) maxw=w;
		if (maxh > h ) maxh=h;

        int[] pixels = new int[w * h];
        int[] pixels2 = new int[maxw * maxh];
	PixelGrabber pg = new PixelGrabber(im, 0,0, w, h, pixels, 0, w);
	try {
	    pg.grabPixels();
	} catch (InterruptedException e) {
	    System.err.println("interrupted waiting for pixels!");
	    return null;
	}

	if ((pg.getStatus() & ImageObserver.ABORT) != 0) {
	    System.err.println("image fetch aborted or errored");
	    return null;
	}


     if (angle==90) {
   	    for (int i = 0; i < maxw; i++) {
	      for (int j = 0; j < maxh; j++) {
		   pixels2[(maxh*(maxw-(i+1)))+j]=pixels[(j * w) + i];
	      }
	     }
        return Toolkit.getDefaultToolkit().createImage(new MemoryImageSource( maxh,maxw,pixels2,0,maxh)  ) ;
       }

      if (angle==180) {
   	  for (int i = 0; i < maxw; i++) {
	      for (int j = 0; j < maxh; j++) {
		     pixels2[((maxh-(j+1)) * maxw) + (maxw-(i+1))]=pixels[(j * w) + i];
	      }
	  }
       return Toolkit.getDefaultToolkit().createImage( new MemoryImageSource(maxw,maxh,pixels2,0,maxw)  ) ;
      }

      if (angle==270) {
   	    for (int i = 0; i < maxw; i++) {
	      for (int j = 0; j < maxh; j++) {
		   pixels2[(maxh*i)+(maxh-(j+1))]=pixels[(j * w) + i];
	      }
	     }
        return Toolkit.getDefaultToolkit().createImage( new MemoryImageSource( maxh,maxw,pixels2,0,maxh) ) ;
       }


       return null;

   }



int [][] table= {
{0,'E',0},
{1,'E',1},
{2,'E',2},
{3,'E',3},
{4,'E',4},
{5,'E',5},
{6,'E',6},
{7,'E',7},
{8,'E',8},
{9,'E',9},
{10,'E',10},
{11,'E',11},
{12,'E',12},
{13,'E',13},
{13,'A',0},
{14,'E',14},
{15,'E',15},
{16,'E',16},
{17,'E',17},
{18,'E',18},
{19,'E',19},
{20,'E',20},
{21,'E',21},
{22,'E',22},
{23,'E',23},
{24,'E',24},
{25,'E',25},
{26,'E',26},
{27,'E',30},
{28,'E',32},
{28,'A',28},
{28,'B',28},
{28,'C',28},
{28,'D',28},
{29,'C',29},
{29,'D',29},
{29,'B',29},
{29,'A',29},
{29,'D',33},
{30,'C',30},
{30,'D',30},
{30,'B',30},
{30,'E',34},
{30,'A',30},
{31,'E',35},
{32,'D',59},
{32,'A',32},
{32,'E',59},
{32,'C',59},
{32,'B',47},
{33,'B',53},
{34,'A',34},
{35,'A',35},
{36,'A',36},
{37,'A',37},
{38,'A',38},
{39,'A',39},
{40,'A',40},
{41,'A',41},
{42,'A',42},
{43,'A',43},
{44,'A',44},
{44,'B',48},
{45,'A',45},
{46,'B',49},
{46,'A',46},
{47,'B',50},
{47,'A',47},
{48,'A',48},
{49,'A',49},
{50,'A',50},
{51,'A',51},
{52,'A',52},
{53,'A',53},
{54,'A',54},
{55,'A',55},
{56,'A',56},
{57,'A',57},
{58,'A',58},
{58,'B',51},
{59,'B',37},
{60,'B',38},
{61,'B',39},
{62,'B',40},
{63,'B',41},
{64,'B',52},
{65,'A',1},
{66,'A',2},
{67,'A',3},
{68,'A',4},
{69,'A',5},
{70,'A',6},
{71,'A',7},
{72,'A',8},
{73,'A',9},
{74,'A',10},
{75,'A',11},
{76,'A',12},
{77,'A',13},
{78,'A',14},
{79,'A',15},
{80,'A',16},
{81,'A',17},
{82,'A',18},
{83,'A',19},
{84,'A',20},
{85,'A',21},
{86,'A',22},
{87,'A',23},
{88,'A',24},
{89,'A',25},
{90,'A',26},
{91,'B',42},
{92,'B',43},
{93,'B',44},
{94,'B',45},
{95,'B',46},
{96,'B',0},
{97,'B',1},
{98,'B',2},
{99,'B',3},
{100,'B',4},
{101,'B',5},
{102,'B',6},
{103,'B',7},
{104,'B',8},
{105,'B',9},
{106,'B',10},
{107,'B',11},
{108,'B',12},
{109,'B',13},
{110,'B',14},
{111,'B',15},
{112,'B',16},
{113,'B',17},
{114,'B',18},
{115,'B',19},
{116,'B',20},
{117,'B',21},
{118,'B',22},
{119,'B',23},
{120,'B',24},
{121,'B',25},
{122,'B',26},
{123,'B',32},
{124,'B',54},
{125,'B',34},
{126,'B',35},
{127,'B',36},
{128,'C',48},
{129,'C',49},
{130,'C',50},
{131,'C',51},
{132,'C',52},
{133,'C',53},
{134,'C',54},
{135,'C',55},
{136,'C',56},
{137,'C',57},
{138,'D',47},
{139,'D',48},
{140,'D',49},
{141,'D',50},
{142,'D',51},
{143,'D',52},
{144,'D',53},
{145,'D',54},
{146,'D',55},
{147,'D',56},
{148,'D',57},
{149,'E',48},
{150,'E',49},
{151,'E',50},
{152,'E',51},
{153,'E',52},
{154,'E',53},
{155,'E',54},
{156,'E',55},
{157,'E',56},
{158,'E',57},
{159,'E',36},
{160,'E',37},
{161,'D',37},
{162,'E',38},
{163,'E',39},
{164,'E',40},
{165,'E',41},
{166,'D',42},
{167,'E',43},
{168,'D',38},
{169,'E',44},
{170,'C',37},
{171,'D',39},
{172,'C',38},
{173,'E',45},
{174,'E',46},
{175,'D',40},
{176,'D',41},
{177,'C',39},
{178,'C',40},
{179,'C',41},
{180,'D',42},
{181,'C',42},
{182,'E',47},
{183,'D',43},
{184,'D',44},
{185,'C',43},
{186,'C',44},
{187,'D',45},
{188,'C',45},
{189,'C',46},
{190,'C',47},
{191,'D',46},
{192,'C',0},
{193,'C',1},
{194,'C',2},
{195,'C',3},
{196,'C',4},
{197,'C',5},
{198,'C',6},
{199,'C',7},
{200,'C',8},
{201,'C',9},
{202,'C',10},
{203,'C',11},
{204,'C',12},
{205,'C',13},
{206,'C',14},
{207,'C',15},
{208,'C',16},
{209,'C',17},
{210,'C',18},
{211,'C',19},
{212,'C',20},
{213,'C',21},
{214,'C',22},
{215,'C',23},
{216,'C',24},
{217,'C',25},
{218,'C',26},
{219,'C',32},
{220,'C',33},
{221,'C',34},
{222,'C',35},
{223,'C',36},
{224,'D',0},
{225,'D',1},
{226,'D',2},
{227,'D',3},
{228,'D',4},
{229,'D',5},
{230,'D',6},
{231,'D',7},
{232,'D',8},
{233,'D',9},
{234,'D',10},
{235,'D',11},
{236,'D',12},
{237,'D',13},
{238,'D',14},
{239,'D',15},
{240,'D',16},
{241,'D',17},
{242,'D',18},
{243,'D',19},
{244,'D',20},
{245,'D',21},
{246,'D',22},
{247,'D',23},
{248,'D',24},
{249,'D',25},
{250,'D',26},
{251,'D',32},
{252,'C',33},
{253,'D',34},
{254,'D',35},
{255,'D',36}
};



}





